#include "Core.h"
#include <string>
#include <fstream>
#include <iomanip>
#include <sys/time.h>

Core::Core()
{ 
  timeval the_time;
  gettimeofday(&the_time,NULL);
  random.seed((long int)the_time.tv_usec);


  index=0;
  int w1,w2;
  for( int i = 0; i < NETSIZE; i++ )
    {
      w1=random(NETSIZE-1);
      w2=random(NETSIZE-1);
      // remove cyclic sets, can't connect to self
      if( w1>=i )
	w1++;
      if( w2>=i )
	w2++;
      while( w1 == w2 )
	{
	  w1=random(NETSIZE-1);
	  w2=random(NETSIZE-1);
	  if( w1>=i )
	    w1++;
	  if( w2>=i )
	    w2++;
	}
      net_input[i][0]=&net[w1];
      net_input[i][1]=&net[w2];
    }
  for( int i = 0; i < SHOWSIZE; i++ )
    {
      w1=random(NETSIZE);
      w2=random(NETSIZE);
      while( w1 == w2 )
	{
	  w1=random(NETSIZE);
	  w2=random(NETSIZE);
	}
      show_input[i][0]=&net[w1];
      show_input[i][1]=&net[w2];
    }
    fire_net();
}

bool Core::logic( const bool& one, const bool& two )
{
  return !(one^two);
}

void Core::fire_net()
{
  for( int i = 0; i < NETSIZE; i++ )
    net[i]=logic(*net_input[i][0],*net_input[i][1]);
  for( int i = 0; i < SHOWSIZE; i++ )
    show[i]=logic(*show_input[i][0],*show_input[i][1]);
}

Core::~Core()
{}

char Core::get()
{
  int get_from;
  for( int i = 0; i < 8; i++ )
    {
      get_from = (index+i);
      get_from %=SHOWSIZE;
      if( get_from == 0 ) fire_net();
      rval[i] = show[get_from];
    }
  index = index+8;
  index%=SHOWSIZE;
  return (char) rval.to_ulong();
}
